//==============================================================================
// Printf - Handles serial IO including C type Printf functions
//
// Version 0.1 - Work in Progress
//
// Major Contributers: Kurt Eckhardt 
// 		Robert V Mahoney Jr
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//==============================================================================
#ifndef _PRINTF_H_
#define _PRINTF_H_
#include <stdarg.h>
#include "baplib.h"	// make sure we have which processor and cpu speed defined.

#ifdef __cplusplus
extern "C" {
#endif

extern int lsprintf(char *out, const char *format, ...);
extern int lvsprintf(char *out, const char *format, va_list ap);

extern int IOPrintf(byte bPin, word wMode, const char *format, ...);
extern int IOVPrintf(byte bPin, word wMode, const char *format,  va_list ap);

extern int DBGPrintf(const char *format, ...);	// quick and dirty to not have to keep passing stuff...
extern void WaitForDBGTransmitComplete();

extern void TASerout(byte bPin, word wMode, const char *pb, byte cb);

extern byte TASerin(byte bPin, byte bfPin, word wMode, char *pb, byte cb, unsigned long lTimeout, word wEOL);

// Define some baud rates
// BUGBUG:: cleanup and move to appropriate header files...
#define BAUDMODE(fInvert, speed)	(word)((((unsigned long)(((F_CPU/8l) +(speed/2)))/((unsigned long)speed)) & 0x3ff) | (fInvert? 0x4000 : 0))
#define I9600	BAUDMODE(true, 9600)
#define I38400	BAUDMODE(true, 38400)
#define I115200 BAUDMODE(true, 115200)

//#define I9600		0x40d0
//#define	I38400		0x4034
//#define I115200		0x4011

#ifdef __cplusplus
}
#endif
#endif /* _PRINTF_H_ */
