//Project Lynxmotion Phoenix
//Description: chr-3, configuration file.
//      All Hardware connections (excl controls) and body dimensions 
//      are configurated in this file. Can be used with V2.0 and above
//Configuration version: V1.0
//Date: Nov 1, 2009
//Programmer: Kurt (aka KurtE)
//
//Hardware setup: ABB2 with ATOM 28 Pro, SSC32 V2, (See further for connections)
//
//NEW IN V1.0
//   - First Release
//
//--------------------------------------------------------------------
// Which type of control(s) do you want to compile in
#define USEXBEE
#define USEPS2
#ifdef USEPS2

// define what pins we will use for 
#ifdef BASICATOMPRO28
#define PS2_DAT		P0
#define PS2_CMD		P1
#define PS2_SEL		P2
#define PS2_CLK		P3
#else
#define PS2_DAT		P24 // P0
#define PS2_CMD		P25 // P1
#define PS2_SEL		P26 // P2
#define PS2_CLK		P27	// P3
#endif
#endif

//[SERIAL CONNECTIONS]
#define cSSC_OUT         P11      	//Output pin for (SSC32 RX) on BotBoard (Yellow)
#define cSSC_IN          P10      	//Input pin for (SSC32 TX) on BotBoard (Blue)
#define cSSC_BAUD        I38400   //SSC32 BAUD rate
//#define cSSC_BAUD        I115200   	//SSC32 BAUD rate
#define	cSSC_BINARYMODE	1			// Define if your SSC-32 card supports binary mode.


// Sound pin
#define SOUND_PIN		P9

//--------------------------------------------------------------------
//[BB2 PIN NUMBERS]
#define cEyesPin       P8
//--------------------------------------------------------------------
//[SSC PIN NUMBERS]
#define cRRCoxaPin      P0   //Rear Right leg Hip Horizontal
#define cRRFemurPin     P1   //Rear Right leg Hip Vertical
#define cRRTibiaPin     P2   //Rear Right leg Knee

#define cRMCoxaPin      P4   //Middle Right leg Hip Horizontal
#define cRMFemurPin     P5   //Middle Right leg Hip Vertical
#define cRMTibiaPin     P6   //Middle Right leg Knee

#define cRFCoxaPin        P8   //Front Right leg Hip Horizontal
#define cRFFemurPin     P9   //Front Right leg Hip Vertical
#define cRFTibiaPin     P10   //Front Right leg Knee

#define cLRCoxaPin        P16   //Rear Left leg Hip Horizontal
#define cLRFemurPin     P17   //Rear Left leg Hip Vertical
#define cLRTibiaPin     P18   //Rear Left leg Knee

#define cLMCoxaPin        P20   //Middle Left leg Hip Horizontal
#define cLMFemurPin     P21   //Middle Left leg Hip Vertical
#define cLMTibiaPin     P22   //Middle Left leg Knee

#define cLFCoxaPin        P24   //Front Left leg Hip Horizontal
#define cLFFemurPin     P25   //Front Left leg Hip Vertical
#define cLFTibiaPin     P26   //Front Left leg Knee
//--------------------------------------------------------------------
//[MIN/MAX ANGLES]
#define cRRCoxaMin1       -750      //Mechanical limits of the Right Rear Leg
#define cRRCoxaMax1       750
#define cRRFemurMin1    -900
#define cRRFemurMax1    550
#define cRRTibiaMin1    -400
#define cRRTibiaMax1    750

#define cRMCoxaMin1       -750      //Mechanical limits of the Right Middle Leg
#define cRMCoxaMax1       750
#define cRMFemurMin1    -900
#define cRMFemurMax1    550
#define cRMTibiaMin1    -400
#define cRMTibiaMax1    750

#define cRFCoxaMin1       -750      //Mechanical limits of the Right Front Leg
#define cRFCoxaMax1       750
#define cRFFemurMin1    -900
#define cRFFemurMax1    550
#define cRFTibiaMin1    -400
#define cRFTibiaMax1    750

#define cLRCoxaMin1       -750      //Mechanical limits of the Left Rear Leg
#define cLRCoxaMax1       750
#define cLRFemurMin1    -900
#define cLRFemurMax1    550
#define cLRTibiaMin1    -400
#define cLRTibiaMax1    750

#define cLMCoxaMin1       -750      //Mechanical limits of the Left Middle Leg
#define cLMCoxaMax1       750
#define cLMFemurMin1    -900
#define cLMFemurMax1    550
#define cLMTibiaMin1    -400
#define cLMTibiaMax1    750

#define cLFCoxaMin1       -750      //Mechanical limits of the Left Front Leg
#define cLFCoxaMax1       750
#define cLFFemurMin1    -900
#define cLFFemurMax1    550
#define cLFTibiaMin1    -400
#define cLFTibiaMax1    750
//--------------------------------------------------------------------
//[BODY DIMENSIONS]
#define cCoxaLength     29      //1.14" = 29mm (1.14 * 25.4)
#define cFemurLength      57     //2.25" = 57mm (2.25 * 25.4)
#define cTibiaLength      141    //5.55" = 141mm (5.55 * 25.4)

#define cRRCoxaAngle1     -600   //Default Coxa setup angle, decimals = 1
#define cRMCoxaAngle1     0      //Default Coxa setup angle, decimals = 1
#define cRFCoxaAngle1     600      //Default Coxa setup angle, decimals = 1
#define cLRCoxaAngle1     -600   //Default Coxa setup angle, decimals = 1
#define cLMCoxaAngle1     0      //Default Coxa setup angle, decimals = 1
#define cLFCoxaAngle1     600      //Default Coxa setup angle, decimals = 1

#define cRROffsetX        -69     //Distance X from center of the body to the Right Rear coxa
#define cRROffsetZ        119     //Distance Z from center of the body to the Right Rear coxa
#define cRMOffsetX        -138    //Distance X from center of the body to the Right Middle coxa
#define cRMOffsetZ        0       //Distance Z from center of the body to the Right Middle coxa
#define cRFOffsetX        -69     //Distance X from center of the body to the Right Front coxa
#define cRFOffsetZ        -119    //Distance Z from center of the body to the Right Front coxa

#define cLROffsetX        69      //Distance X from center of the body to the Left Rear coxa
#define cLROffsetZ        119     //Distance Z from center of the body to the Left Rear coxa
#define cLMOffsetX        138     //Distance X from center of the body to the Left Middle coxa
#define cLMOffsetZ        0       //Distance Z from center of the body to the Left Middle coxa
#define cLFOffsetX        69      //Distance X from center of the body to the Left Front coxa
#define cLFOffsetZ        -119    //Distance Z from center of the body to the Left Front coxa

//--------------------------------------------------------------------
//[START POSITIONS FEET]
#define cRRInitPosX     52      //Start positions of the Right Rear leg
#define cRRInitPosY     80
#define cRRInitPosZ     91

#define cRMInitPosX     105      //Start positions of the Right Middle leg
#define cRMInitPosY     80
#define cRMInitPosZ     0

#define cRFInitPosX     52      //Start positions of the Right Front leg
#define cRFInitPosY     80
#define cRFInitPosZ     -91

#define cLRInitPosX     52      //Start positions of the Left Rear leg
#define cLRInitPosY     80
#define cLRInitPosZ     91

#define cLMInitPosX     105      //Start positions of the Left Middle leg
#define cLMInitPosY     80
#define cLMInitPosZ     0

#define cLFInitPosX     52      //Start positions of the Left Front leg
#define cLFInitPosY     80
#define cLFInitPosZ     -91
//--------------------------------------------------------------------
