#include "globals.h"

// get string length
u32 strlen (char *_pstr)
{
	char *s;

	s = _pstr;
	while (*s)
		s++;
	return (u32) (s - _pstr);
}

// reverse string
char *strrev (char *_pstr) 
{
	char *s1, *s2;

	if (!_pstr || !*_pstr)
		return _pstr;
	for (s1 = _pstr, s2 = _pstr + strlen(_pstr) - 1; s2 > s1; ++s1, --s2)
	{
		*s1 ^= *s2;
		*s2 ^= *s1;
		*s1 ^= *s2;
	}
	return _pstr;
}

// copy string
char *strcpy (char *_psdest, char *_pssource)
{
	while (*_pssource != 0)
		*_psdest++ = *_pssource++;
	*_psdest = 0;
	return _psdest;
}

// concatenate string
char *strcat (char *_psdest, char *_pssource)
{
	char *pdest = (_psdest+strlen (_psdest));
	strcpy (pdest, _pssource);
	return _psdest;
}

// 32 bit value to string using selected base
char *itoa (u32 _lvalue, char *_psresult, u8 bbase)
{
	unsigned long t = 0, res = 0;
	unsigned long tmp = _lvalue;
	int count = 0;

	if (tmp == 0)
		count++;
	while(tmp > 0)
	{
		tmp = tmp/bbase;
		count++;
	}
	_psresult += count;
	*_psresult = '\0';
	do
	{
		res = _lvalue - bbase * (t = _lvalue / bbase);
		if (res < 10)
			*--_psresult = '0' + (char) res;
		else if ((res >= 10) && (res < 16))
			*--_psresult = 'A' - 10 + (char) res;
	} while ((_lvalue = t) != 0);
	return(_psresult);
}

void strpad (char *_pstr, char _cpad, u16 _wpadlength)
{
	u16 wlength = strlen(_pstr);
	u16 wpadlength = _wpadlength-wlength;
	u16 wloop;
	char *psrc = (_pstr+(wlength-1));
	char *pdest = (_pstr+wpadlength+(wlength-1));

	*(pdest+1) = 0;
	for (wloop=0; wloop<wlength; wloop++)
		*pdest-- = *psrc--;
	for (wloop=0; wloop<wpadlength; wloop++)
		*_pstr++ = _cpad;
}

//==============================================================================
// Simple function to see if two things are the same...
//==============================================================================
bool FCompareMem(const char *pb1, const char *pb2, unsigned char cb)
{
	while (cb-- > 0)
	{
		if (*pb1++ != *pb2++)
			return false;
	}
	return true;
	
}

